]> git.xonotic.org Git - xonotic/xonotic.git/blob - misc/tools/xonotic-map-compiler-autobuild
Merge branch 'master' of git://de.git.xonotic.org/xonotic/xonotic
[xonotic/xonotic.git] / misc / tools / xonotic-map-compiler-autobuild
1 #!/bin/sh
2
3 set -e
4
5 bspdir="$PWD/data"
6 url_http=http://beta.xonotic.org/autobuild-bsp/
7 url_ssh=xonotic-beta:autobuild-bsp/
8 build_cachedir="$HOME/xonotic-map-compiler.cache/"
9 screenshot_cachedir="$HOME/xonotic-map-screenshot.cache/"
10 build_override="-bsp_timeout 5400 -vis_timeout 3600 -light_timeout 14400 -minimap_timeout 900 -scale_timeout 900"
11 screenshot_override="9 900 5 +g_ctf 1"
12
13 getthemap_fail=false
14
15 allmaps()
16 {
17         commithash=$1
18         shift
19         for F in `git show "${commithash}:maps/"`; do
20                 case "$F" in
21                         *.map.options)
22                                 ;;
23                         *)
24                                 continue
25                                 ;;
26                 esac
27                 M=${F%.map.options}
28                 blobhash=`git rev-parse --revs-only "${commithash}:maps/$M.map.options" || true`-`git rev-parse --revs-only "${commithash}:maps/$M.map" || true`
29                 case "$blobhash" in
30                         -*)
31                                 ;;
32                         *-)
33                                 ;;
34                         *)
35                                 "$@" "$M" "$blobhash" "$commithash"
36                                 ;;
37                 esac
38         done
39 }
40
41 pre2spam()
42 {
43         map=$1
44         url=$2
45         branch=$3
46         hash=$4
47
48         branch=${branch##refs/heads/}
49         branch=${branch##refs/remotes/}
50         branch=${branch##origin/}
51         hash=`echo "$hash" | cut -c 1-7`
52
53         echo "[$branch $hash] starting map compile of $map"
54 }
55
56 ss2spam()
57 {
58         map=$1
59         url=$2
60         branch=$3
61         hash=$4
62         status=$5
63
64         branch=${branch##refs/heads/}
65         branch=${branch##refs/remotes/}
66         branch=${branch##origin/}
67         hash=`echo "$hash" | cut -c 1-7`
68
69         s_error=
70
71         if [ "$status" -ne 0 ]; then
72                 s_error="exited with status $status"
73         fi
74
75         if [ -n "$s_error" ]; then
76                 echo "[$branch $hash] \ 34screenshots of $map could not be made: $s_error"
77         else
78                 echo "[$branch $hash] screenshots of $map are available on $url"
79         fi
80 }
81
82 log2spam()
83 {
84         map=$1
85         url=$2
86         branch=$3
87         hash=$4
88         status=$5
89         time=$6
90
91         hash=`echo "$hash" | cut -c 1-7`
92
93         branch=${branch##refs/heads/}
94         branch=${branch##refs/remotes/}
95         branch=${branch##origin/}
96
97         s_samplesize=
98         s_failshaders=
99         s_leaked=
100         s_error=
101
102         if [ "$status" -ne 0 ]; then
103                 s_error="exited with status $status"
104         fi
105         while IFS= read -r L; do
106                 case "$L" in
107                         WARNING:\ surface\ at\ *\ too\ large\ for\ desired\ samplesize*)
108                                 s=${L##* }
109                                 if [ -z "$s_samplesize" ] || [ "$s" -gt "$s_samplesize" ]; then
110                                         s_samplesize=$s
111                                 fi
112                                 ;;
113                         WARNING:\ Couldn\'t\ find\ image\ for\ shader\ textures/NULL)
114                                 # radiant stupid
115                                 ;;
116                         WARNING:\ Couldn\'t\ find\ image\ for\ shader\ *)
117                                 s_failshaders="$s_failshaders ${L##* }"
118                                 ;;
119                         ERROR:\ *)
120                                 if [ -z "$s_error" ]; then
121                                         s_error=$L
122                                 fi
123                                 ;;
124                         '******* leaked *******')
125                                 s_leaked=1
126                                 ;;
127                         '************ ERROR ************')
128                                 IFS= read -r s_error
129                                 ;;
130                 esac
131         done
132         s_failshaders=`echo "$s_failshaders" | sed "s, textures/, ,g"`
133         s_failshaders=${s_failshaders# }
134         if [ -n "$s_error" ]; then
135                 echo -n "[$branch $hash] \ 34failed"
136         else
137                 echo -n "[$branch $hash] finished"
138         fi
139         echo -n " map compile of $map ($url): $time sec"
140         if [ -n "$s_samplesize" ]; then
141                 echo -n ", FIX samplesize >= $s_samplesize"
142         fi
143         if [ -n "$s_failshaders" ]; then
144                 if [ -n "`echo "$s_failshaders" | cut -d ' ' -f 4-`" ]; then
145                         s_failshaders="`echo "$s_failshaders" | cut -d ' ' -f 1-3`..."
146                 fi
147                 echo -n ", FIX shaders $s_failshaders"
148         fi
149         if [ -n "$s_leaked" ]; then
150                 echo -n ", FIX LEAK"
151         fi
152         if [ -n "$s_error" ]; then
153                 s_error=`echo "$s_error" | sed "s,$PWD/\?,,g"`
154                 echo -n ", ERROR: $s_error"
155         fi
156         echo
157 }
158
159 buildthemap()
160 {
161         REFNAME=$1
162         url=$2
163         M=$3
164         blobhash=$4
165         commithash=$5
166         if lwp-request -m HEAD "$url$M-$blobhash.pk3"; then
167                 continue
168         fi
169
170         git reset --hard
171         git clean -xfd
172         git checkout -f "$commithash"
173
174         if [ -n "$IRCSPAM" ]; then
175                 pre2spam "$M" "$url$M-$blobhash.pk3" "$REFNAME" "$commithash" | $IRCSPAM || true
176         fi
177         t0=`date +%s`
178         (
179                 cd maps
180                 sz=`grep '^size ' "$M.mapinfo" 2>/dev/null || true`
181                 if [ -n "$sz" ]; then
182                         minimap_override="-minimap + -minmax ${sz#size }"
183                 else
184                         minimap_override=
185                 fi
186                 ../../../misc/tools/xonotic-map-compiler "$M" `grep ^- "$M.map.options" | cut -d '#' -f 1` $minimap_override $build_override > "$M.log" 2>&1
187         )
188         status=$?
189         if ! [ -f "maps/$M.bsp" ]; then
190                 echo >>"$M.log" "ERROR: No BSP file"
191         fi
192         t1=`date +%s`
193         dt=$(($t1 - $t0))
194         if [ -n "$IRCSPAM" ]; then
195                 cat "maps/$M.log" | log2spam "$M" "$url$M-$blobhash.pk3" "$REFNAME" "$commithash" "$status" "$dt" > "maps/$M.irc"
196         fi
197         zip -9r "$M-$blobhash.pk3" "maps/$M.bsp" "maps/$M.log" "maps/$M.irc" "maps/$M/" "maps/$M.lin" "gfx/${M}_mini.tga"
198         ln -snf "../$M-$blobhash.pk3" "$M.pk3" # from ALL branches, so beware!
199         cp "$M-$blobhash.pk3" "$M-full-$blobhash.pk3"
200         zip -9r "$M-full-$blobhash.pk3" `git diff --name-only --diff-filter=ACMRTUXB master...HEAD` || true
201         ln -snf "../$M-full-$blobhash.pk3" "$M-full.pk3" # from ALL branches, so beware!
202         rsync -vaSHP "$M-$blobhash.pk3" "$M-full-$blobhash.pk3" "$url_ssh"
203         rsync -vaSHP "$M.pk3" "$M-full.pk3" "$url_ssh""latest/"
204         if [ -n "$IRCSPAM" ]; then
205                 $IRCSPAM < "maps/$M.irc" || true
206         fi
207         if [ -n "$BUILD_ONE" ]; then
208                 exit
209         fi
210 }
211
212 screenshotthemap()
213 {
214         REFNAME=$1
215         url=$2
216         M=$3
217         blobhash=$4
218         commithash=$5
219         if lwp-request -m HEAD "$url$M-$blobhash/"; then
220                 continue
221         fi
222
223         if ! unzip -l "$bspdir/$M-$blobhash.pk3" "maps/$M.bsp"; then
224                 # no BSP file
225                 continue
226         fi
227
228         rm -rf ~/.xonotic/data
229         mkdir -p ~/.xonotic/data
230         (
231                 cd ../..
232                 if [ -n "$DISPLAY" ]; then
233                         misc/tools/xonotic-map-screenshot "$M" $screenshot_override $DRIVERFLAGS +"scr_screenshot_name \"$M-\""
234                 else
235                         case "$DRIVER" in
236                                 gl)
237                                         startx "$PWD/misc/tools/xonotic-map-screenshot" "$M" $screenshot_override $DRIVERFLAGS +"scr_screenshot_name \"$M-\"" -- :8
238                                         ;;
239                                 soft|*)
240                                         startx "$PWD/misc/tools/xonotic-map-screenshot" "$M" $screenshot_override +"vid_soft 1" $DRIVERFLAGS +"scr_screenshot_name \"$M-\"" -- /usr/bin/Xvfb :8 -screen 0 1024x768x24
241                                         ;;
242                         esac
243                 fi
244         ) 2>&1 | tee ~/.xonotic/data/autoscreenshot.log
245         good=false
246         if mv ~/.xonotic/data/screenshots "$M-$blobhash"; then
247                 ss2spam "$M" "$url?d" "$REFNAME" "$commithash" 0 > ~/.xonotic/data/"$M.ircss"
248         else
249                 mkdir "$M-$blobhash"
250                 ss2spam "$M" "$url?d" "$REFNAME" "$commithash" 1 > ~/.xonotic/data/"$M.ircss"
251         fi
252         mv ~/.xonotic/data/"$M.ircss" "$M-$blobhash"/
253         mv ~/.xonotic/data/autoscreenshot.log "$M-$blobhash"/
254         chmod 1777 "$M-$blobhash"
255         ln -snf "../$M-$blobhash" "$M" # from ALL branches, so beware!
256         rsync -vaSHP "$M-$blobhash" "$url_ssh"
257         rsync -vaSHP "$M" "$url_ssh""latest/"
258         if [ -n "$IRCSPAM" ]; then
259                 $IRCSPAM < "$M-$blobhash/$M.ircss" || true
260         fi
261         if [ -n "$BUILD_ONE" ]; then
262                 exit
263         fi
264 }
265
266 getthemap()
267 {
268         url=$1
269         bspdir_old=$2
270         bspdir=$3
271         M=$4
272         blobhash=$5
273         commithash=$6
274         if mv "$bspdir_old/$M-$blobhash.pk3" "$bspdir/$M-$blobhash.pk3"; then
275                 if unzip -l "$bspdir/$M-$blobhash.pk3" >/dev/null 2>&1; then
276                         return 0
277                 fi
278         fi
279         if ! wget -c -O "$bspdir/$M-$blobhash.pk3" "$url$M-$blobhash.pk3"; then
280                 if ! curl -o "$bspdir/$M-$blobhash.pk3" "$url$M-$blobhash.pk3"; then
281                         rm -f "$bspdir/$M-$blobhash.pk3"
282                         echo "WARNING: could not download $url$M-$blobhash.pk3, maybe not ready yet"
283                         getthemap_fail=true
284                         return 0
285                 fi
286         fi
287         if ! unzip -l "$bspdir/$M-$blobhash.pk3"; then
288                 rm -f "$bspdir/$M-$blobhash.pk3"
289                 echo "WARNING: could not download $url$M-$blobhash.pk3, invalid zip file"
290                 getthemap_fail=true
291                 return 0
292         fi
293 }
294
295 indexthemap()
296 {
297         REFNAME=$1
298         M=$2
299         blobhash=$3
300         commithash=$4
301         echo "$M $blobhash $commithash $REFNAME"
302 }
303
304 rundownload()
305 {
306         mkdir -p "$bspdir" "$bspdir.old"
307         for b in "$bspdir"/*-????????????????????????????????????????-????????????????????????????????????????.pk3; do
308                 if [ -e "$b" ]; then
309                         mv "$b" "$bspdir.old"/
310                 fi
311         done
312         allmaps "HEAD" getthemap "$url_http" "$bspdir.old" "$bspdir"
313 }
314
315 branches()
316 {
317         git for-each-ref 'refs/remotes' | grep -vE '    refs/remotes/([^/]*/HEAD|.*/archived/.*)$'
318 }
319
320 runmakeindex()
321 {
322         cd data/xonotic-maps.pk3dir
323         branches | while read -r HASH TYPE REFNAME; do
324                 allmaps "$HASH" indexthemap "$REFNAME"
325         done
326         cd ../..
327 }
328
329 case "$1" in
330         build)
331                 cd data/xonotic-maps.pk3dir
332                 branches | while read -r HASH TYPE REFNAME; do
333                         if [ -f "$build_cachedir/$HASH" ]; then
334                                 continue
335                         fi
336                         allmaps "$HASH" buildthemap "$REFNAME" "$url_http"
337                         touch "$build_cachedir/$HASH"
338                 done
339                 git checkout -f master
340                 ;;
341         screenshot)
342                 runmakeindex > "branches.idx.new"
343                 rsync -vaSHP "branches.idx.new" "$url_ssh""branches.idx.new"
344                 rm -f "branches.idx.new"
345                 cd data/xonotic-maps.pk3dir
346                 branches | while read -r HASH TYPE REFNAME; do
347                         if [ -f "$screenshot_cachedir/$HASH" ]; then
348                                 continue
349                         fi
350
351                         git reset --hard
352                         git clean -xfd
353                         git checkout -f "$HASH"
354
355                         rundownload
356                         if $getthemap_fail; then
357                                 continue
358                         fi
359
360                         allmaps "$HASH" screenshotthemap "$REFNAME" "$url_http"
361
362                         touch "$screenshot_cachedir/$HASH"
363                 done
364                 git checkout -f master
365                 ;;
366         makeindex)
367                 runmakeindex
368                 ;;
369         download)
370                 if ! which unzip >/dev/null 2>&1; then
371                         echo "Cannot find unzip, bailing out"
372                         exit 1
373                 fi
374                 if ! cd data/xonotic-maps.pk3dir >/dev/null 2>&1; then
375                         echo "data/xonotic-maps.pk3dir does not exist, not downloading"
376                         exit 0
377                 fi
378                 rundownload
379                 cd ../..
380                 echo "List of maps that got deleted (if any) and currently are in $bspdir.old:"
381                 ls -l "$bspdir.old" || true
382                 ;;
383         download-latest)
384                 mkdir -p "$bspdir"
385                 cd "$bspdir"
386                 rm -f *-????????????????????????????????????????-????????????????????????????????????????.pk3
387                 wget -r -l1 -A "*.pk3" -N --no-parent --no-directories "$url_http""latest"
388                 ;;
389         log2spam-test)
390                 log2spam "mapname" "http://mapurl" "branch" "commit" "0"
391                 ;;
392 esac